//-------------------------------------------------------
//  spring2sensor.cpp
//
//	2009N615 (June 15th, 2009)
//	Y (Kojiro MATSUSHITA)
//     http://www.koj-m.sakura.ne.jp/ode/
//
//	yezLkol𗘗p̓ZT+Gnuplotɂf[^̃Ot\
//  	̃vOR[h́CODẼfvOudemo_buggy.cppv̍\
//	Â쐬Ă܂DeƂẮC{bNX^2XC_֐߂Őڑ
//	֐ߏԁESeݒ肵CLkolƂĂ܂DăXC_֐߂
//	ړʁol̐LkʂvCeW|(tbN̖@)C
//	XC_֐߂ɉ͂ZoĂ܂.̒lR}hvvg
//@	\܂D
//

//@yӁz
//@V~[V\zŁCݎDTEd́ESeK,C̐ݒ肪dvƂȂ܂.
//  Ȃ킿CݎԂ傫CSed肷ƕ̂͒nʂƂ̐ڐG
//  U傫Ȕ͂̂ߔĂ܂܂.܂Cd͂nƗގۂ
//  ̂Ȃ9.8Ɛݒ肷ׂł傤.
//  ŌFDSC͂܂Ŏԗ֌^̂߂̖CݒȂ̂ŁC{V~[Vł
//  Kv܂.tɒnʂɐÎ~̂ɂׂƂςȌۂN
//  ܂܂̂ŁCݒ폜Ă.
//
//--------------------------------------------------------

#include <ode/ode.h>
#include <drawstuff/drawstuff.h>
#include "texturepath.h"

#ifdef _MSC_VER
#pragma warning(disable:4244 4305)  // for VC++, no precision loss complaints
#endif

// select correct drawing functions

#ifdef dDOUBLE
#define dsDrawBox dsDrawBoxD
#define dsDrawSphere dsDrawSphereD
#define dsDrawCylinder dsDrawCylinderD
#define dsDrawCapsule dsDrawCapsuleD
#endif


// some constants

// 0̃TCYd
#define LENGTH0	0.7	// length
#define WIDTH0	0.5	// width
#define HEIGHT0	0.2	// height
#define MASS0	1		// mass

// 1̃TCYd
#define LENGTH1 0.7	// length
#define WIDTH1	0.5	// width
#define HEIGHT1 0.2	// height
#define MASS1	1		// mass
#define STARTZ  0.7	// starting height of chassis

// ݎ
#define DT	0.001

// XC_֐߂̒evfESvf
#define K	10000.
#define C	1000.

// nʂ̒evfESvf
#define GK	10000.
#define GC	100.00

static dWorldID world;
static dSpaceID space;
static dBodyID body[2];
static dJointID joint[1];	// joint[0] is the front wheel
static dJointGroupID contactgroup;
static dGeomID ground;
static dSpaceID car_space;
static dGeomID box[2];

double t=0;
FILE *fp;

static void nearCallback (void *data, dGeomID o1, dGeomID o2)
{
  int i,n;

  const int N = 10;
  dContact contact[N];
  n = dCollide (o1,o2,N,&contact[0].geom,sizeof(dContact));	// n͐ڐG
  if (n > 0) {
    for (i=0; i<n; i++) {
      contact[i].surface.mode = //dContactSlip1 | dContactSlip2 |
	dContactSoftERP | dContactSoftCFM | dContactApprox1;
      contact[i].surface.mu = dInfinity;
      //contact[i].surface.slip1 = 0.1;
      //contact[i].surface.slip2 = 0.1;
	  // FDSCƁC{bNX^ł͕sRȂׂ茻ۂ
	  // Ă܂߁Cݒ薳ɂĂ܂D
	
      contact[i].surface.soft_erp = (DT*GK)/(DT*GK+GC);
      contact[i].surface.soft_cfm = 1/(DT*GK+GC);
	  // eWGKƔSWGCłׂĂ̏̕Փ˂d߂ɐݒD
      dJointID c = dJointCreateContact (world,contactgroup,&contact[i]);
      dJointAttach (c,
		    dGeomGetBody(contact[i].geom.g1),
		    dGeomGetBody(contact[i].geom.g2));
    }
  }
}


// start simulation - set viewpoint

static void start()
{
  dAllocateODEDataForThread(dAllocateMaskAll);

  static float xyz[3] = {0.8317f,-0.9817f,0.8000f};
  static float hpr[3] = {121.0000f,-27.5000f,0.0000f};
  dsSetViewpoint (xyz,hpr);
}


// called when a key pressed

static void command (int cmd)
{
  switch (cmd) {
  case 'a': case 'A':
    break;
  case 'z': case 'Z':
    break;
  }
}


// simulation loop

static void simLoop (int pause)
{
  int i;
  if (!pause) {

	// ̓ZT
    // Lkol̕ωʁiXC_֐߂̕ωʁjɒeWK|ė͂ɊZ
    // F=KX
	printf(":%2.3f[b]	̓ZTlF%f[N]\n",t,-K*dJointGetSliderPosition(joint[0]));

    dSpaceCollide (space,0,&nearCallback);
    dWorldStep (world,DT);
	t=t+DT;

    // remove all contact joints
    dJointGroupEmpty (contactgroup);
  }

  dReal sides0[3] = {LENGTH0,WIDTH0,HEIGHT0};
  dsSetColor (0,0,1);
  dsDrawBox (dBodyGetPosition(body[0]),dBodyGetRotation(body[0]),sides0);

  dReal sides1[3] = {LENGTH1,WIDTH1,HEIGHT1}; 
  dsSetColor (1,0,1);
  dsDrawBox (dBodyGetPosition(body[1]),dBodyGetRotation(body[1]),sides1);

  if(t>1.0)dsStop();
}


int main (int argc, char **argv)
{
  int i;
  dMass m;

  // setup pointers to drawstuff callback functions
  dsFunctions fn;
  fn.version = DS_VERSION;
  fn.start = &start;
  fn.step = &simLoop;
  fn.command = &command;
  fn.stop = 0;
  fn.path_to_textures = DRAWSTUFF_TEXTURE_PATH;
  if(argc==2)
    {
        fn.path_to_textures = argv[1];
    }

  // create world
  dInitODE2(0);
  world = dWorldCreate();
  space = dHashSpaceCreate (0);
  contactgroup = dJointGroupCreate (0);
  dWorldSetGravity (world,0,0,-9.8);
  ground = dCreatePlane (space,0,0,1,0);

  // {bNX^2ŐLkol̍\z
  // BOX0
  body[0] = dBodyCreate (world);
  dBodySetPosition (body[0],0,0,STARTZ);
  dMassSetBox (&m,1,LENGTH0,WIDTH0,HEIGHT0);
  dMassAdjust (&m,MASS0);
  dBodySetMass (body[0],&m);
  box[0] = dCreateBox (0,LENGTH0,WIDTH0,HEIGHT0);
  dGeomSetBody (box[0],body[0]);

  // BOX1
  body[1] = dBodyCreate (world);
  dBodySetPosition (body[1],0,0,STARTZ-0.5*(HEIGHT0+HEIGHT1));
  dMassSetBox (&m,1,LENGTH1,WIDTH1,HEIGHT1);
  dMassAdjust (&m,MASS1);
  dBodySetMass (body[1],&m);
  box[1] = dCreateBox (0,LENGTH1,WIDTH1,HEIGHT1);
  dGeomSetBody (box[1],body[1]);


  // Lkol\邽̃XC_֐߂̐ݒ
  i=0;
  joint[i] = dJointCreateSlider (world,0);
  dJointAttach (joint[i],body[0],body[1]);
  dJointSetSliderAxis (joint[i],0,0,1);

  // iEɁjOƂC
  dJointSetSliderParam (joint[i],dParamLoStop,0);
  dJointSetSliderParam (joint[i],dParamHiStop,0);

  // 搧̔Se𒲐CLkolƂ
  dJointSetSliderParam (joint[i],dParamStopERP,(DT*K)/(DT*K+C)); 
  dJointSetSliderParam (joint[i],dParamStopCFM,1/(DT*K+C));

  car_space = dSimpleSpaceCreate (space);
  dSpaceSetCleanup (car_space,0);
  dSpaceAdd (car_space,box[0]);
  dSpaceAdd (car_space,box[1]);

  // run simulation
  dsSimulationLoop (argc,argv,640,480,&fn);

  dGeomDestroy (box[0]);
  dGeomDestroy (box[1]);
  dJointGroupDestroy (contactgroup);
  dSpaceDestroy (space);
  dWorldDestroy (world);
  dCloseODE();
  return 0;
}
